diff --git a/src/PropertyConfiguratorImpl.cpp b/src/PropertyConfiguratorImpl.cpp
index b96a774..af14090 100644
--- a/src/PropertyConfiguratorImpl.cpp
+++ b/src/PropertyConfiguratorImpl.cpp
@@ -25,6 +25,7 @@
 #include <log4cpp/OstreamAppender.hh>
 #include <log4cpp/FileAppender.hh>
 #include <log4cpp/RollingFileAppender.hh>
+#include <log4cpp/TimeRollingFileAppender.hh>
 #include <log4cpp/AbortAppender.hh>
 #ifdef WIN32
 #include <log4cpp/Win32DebugAppender.hh>
@@ -54,8 +55,13 @@
 #include "PropertyConfiguratorImpl.hh"
 #include "StringUtil.hh"
 
+// event 
+#include <log4cpp/EventBase.hh>
+
 namespace log4cpp {
 
+	extern EventBase gEventBase;
+
     PropertyConfiguratorImpl::PropertyConfiguratorImpl() {
     }
 
@@ -203,16 +209,59 @@ namespace log4cpp {
         }
         else if (appenderType == "FileAppender") {
             std::string fileName = _properties.getString(appenderPrefix + ".fileName", "foobar");
+            bool isAsyncFlush = _properties.getInt(appenderPrefix + ".async_flush", false);
+            int flushThresholdInKB = _properties.getInt(appenderPrefix + ".flush_threshold", 1024); // 1k
+            int flushInterval = _properties.getInt(appenderPrefix + ".flush_interval", 1000); // 1s
             bool append = _properties.getBool(appenderPrefix + ".append", true);
             appender = new FileAppender(appenderName, fileName, append);
+			appender->setFlushThresholdInKB(flushThresholdInKB);
+			appender->setFlushInterval(flushInterval);
+			appender->setAsyncFlush(isAsyncFlush);
+			if (appender->isAsyncFlush()) {
+				gEventBase.AddLayoutAppender((FileAppender *)appender);
+			}
         }
         else if (appenderType == "RollingFileAppender") {
             std::string fileName = _properties.getString(appenderPrefix + ".fileName", "foobar");
             size_t maxFileSize = _properties.getInt(appenderPrefix + ".maxFileSize", 10*1024*1024);
             int maxBackupIndex = _properties.getInt(appenderPrefix + ".maxBackupIndex", 1);
             bool append = _properties.getBool(appenderPrefix + ".append", true);
-            appender = new RollingFileAppender(appenderName, fileName, maxFileSize, maxBackupIndex,
-                append);
+            appender = new RollingFileAppender(appenderName, fileName, maxFileSize, maxBackupIndex, append);
+        }
+        else if (appenderType == "TimeRollingFileAppender") {
+            std::string fileName = _properties.getString(appenderPrefix + ".fileName", "foobar");
+            size_t maxFileAge = _properties.getInt(appenderPrefix + ".maxFileAge", 24*60*60);
+            int maxBackupIndex = _properties.getInt(appenderPrefix + ".maxBackupIndex", 0);
+            std::string backupPattern = _properties.getString(appenderPrefix + ".backupPattern", "%Y%m%d-%H:%M:%S");
+            bool append = _properties.getBool(appenderPrefix + ".append", true);
+            appender = new TimeRollingFileAppender(appenderName, fileName, maxFileAge, backupPattern, append);
+			appender->setBackupIndex(maxBackupIndex);
+        }
+        else if (appenderType == "AmberAppender") {
+            std::string config = _properties.getString(appenderPrefix + ".config", "");
+            if (config.empty()) {
+                throw ConfigureFailure(std::string("property 'config' must be set. appenderName: ") + appenderName);
+            }
+            int category = _properties.getInt(appenderPrefix + ".category", -1);
+            if (category == -1) {
+                throw ConfigureFailure(std::string("property 'category' must be set. appenderName: ") + appenderName);
+            }
+            int version = _properties.getInt(appenderPrefix + ".version", 0);
+            std::string queueName = _properties.getString(appenderPrefix + ".queueName", "log_queue");
+            int subqueueId = _properties.getInt(appenderPrefix + ".subqueueId", 1);
+            int bufferThreshold = _properties.getInt(appenderPrefix + ".bufferThreshold", 102400);
+            InstantiateAmberAppender* instantiate = getInstantiateAmberAppender();
+            if (instantiate == NULL) {
+                throw ConfigureFailure(std::string("instantiate AmberAppender failed. "
+                		"You SHOULD call AmberAppender::registerClass() "
+                		"before PropertyConfigurator::configure() to fix this. appenderName: ") + appenderName);
+            }
+            appender = (*instantiate)(appenderName, config,
+                    category, version, queueName, subqueueId, bufferThreshold);
+            if (appender == NULL) {
+                throw ConfigureFailure(std::string("instantiate AmberAppender failed. "
+                        "appenderName: ") + appenderName);
+            }
         }
         else if (appenderType == "SyslogAppender") {
             std::string syslogName = _properties.getString(appenderPrefix + ".syslogName", "syslog");
diff --git a/src/RemoteSyslogAppender.cpp b/src/RemoteSyslogAppender.cpp
index 6243bbb..ed28c8d 100644
--- a/src/RemoteSyslogAppender.cpp
+++ b/src/RemoteSyslogAppender.cpp
@@ -13,7 +13,7 @@
 #    include <unistd.h>
 #endif
 #include <cstdlib>
-#include <stdio.h>
+#include <cstdio>
 #include <cstring>
 #include <sys/types.h>
 #include <sys/stat.h>
diff --git a/src/Signaler.cpp b/src/Signaler.cpp
new file mode 100644
index 0000000..113000d
--- /dev/null
+++ b/src/Signaler.cpp
@@ -0,0 +1,87 @@
+#include <log4cpp/Signaler.hh>
+#include <assert.h>
+#include <errno.h>
+#include <unistd.h>
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <fcntl.h>
+
+namespace log4cpp
+{
+
+Signaler::Signaler()
+{
+    // Create the socketpair for signaling.
+    int rc = makeFdPair(m_readFd, m_writeFd);
+    assert(rc == 0);
+    
+    // Set both fds to non-blocking mode.
+    setSocketUnblock(m_writeFd);
+    setSocketUnblock(m_readFd);
+}
+
+Signaler::~Signaler()
+{
+    int rc;
+    rc = close(m_writeFd);
+    assert(rc == 0);
+
+    rc = close(m_readFd);
+    assert(rc == 0);
+}
+
+void Signaler::send()
+{
+    // Write one byte to the underlying socket, so that
+    // the read fd's POLLIN event can be fired in the I/O thread.
+    unsigned char dummy = 0;
+    while (true) 
+    {
+        ssize_t nbytes = ::send(m_writeFd, &dummy, sizeof(dummy), 0);
+        if (unlikely(nbytes == -1 && errno == EINTR))
+            continue;
+        assert(nbytes == sizeof(dummy));
+        break;
+    }
+}
+
+int Signaler::recv()
+{
+    unsigned char dummy[4];
+
+    ssize_t nbytes = 0;
+    while (true)
+    {
+        nbytes = ::recv(m_readFd, dummy, sizeof(dummy), 0);
+        if (unlikely(nbytes == -1 && errno == EINTR))
+            continue;
+        break;
+    }
+    
+    assert(nbytes >= 0);
+    return nbytes;
+}
+
+int Signaler::makeFdPair(int &readFd, int &writeFd)
+{
+    int sv[2] = {0};
+    int rc = socketpair(AF_UNIX, SOCK_STREAM, 0, sv);
+    assert(rc == 0);
+    
+    writeFd = sv[0];
+    readFd = sv[1];
+    
+    return 0;
+}
+
+void Signaler::setSocketUnblock(int socket)
+{
+    int flags = fcntl (socket, F_GETFL, 0);
+    if (flags == -1)
+        flags = 0;
+    int rc = fcntl (socket, F_SETFL, flags | O_NONBLOCK);
+    assert(rc != -1);
+}
+
+}
+
diff --git a/src/Thread.cpp b/src/Thread.cpp
new file mode 100644
index 0000000..eb0ec58
--- /dev/null
+++ b/src/Thread.cpp
@@ -0,0 +1,34 @@
+#include <log4cpp/Thread.hh>
+#include <assert.h>
+#include <signal.h>
+
+static void *thread_routine(void *pArg)
+{
+    // Following code will guarantee more predictable latencies as it'll
+    // disallow any signal handling in the I/O thread.
+    sigset_t signal_set;
+    int rc = sigfillset(&signal_set);
+    assert(rc == 0);
+    rc = pthread_sigmask(SIG_BLOCK, &signal_set, NULL);
+    assert(rc == 0);
+
+    log4cpp::CThread *self = (log4cpp::CThread *)pArg;
+    self->m_tfn(self->m_pArg);
+    
+    return NULL;
+}
+
+void log4cpp::CThread::start(thread_fn *tfn, void *pArg)
+{
+    m_tfn = tfn;
+    m_pArg = pArg;
+    int rc = pthread_create(&m_threadDescriptor, NULL, thread_routine, this);
+    assert(rc == 0);
+}
+
+void log4cpp::CThread::stop()
+{
+    int rc = pthread_join(m_threadDescriptor, NULL);
+    assert(rc == 0);
+}
+
diff --git a/src/TimeRollingFileAppender.cpp b/src/TimeRollingFileAppender.cpp
new file mode 100644
index 0000000..e167278
--- /dev/null
+++ b/src/TimeRollingFileAppender.cpp
@@ -0,0 +1,212 @@
+/*
+ * TimeRollingFileAppender.cpp
+ *
+ * Copyright 2009, Thomas Zhang. All rights reserved.
+ *
+ * See the COPYING file for the terms of usage and distribution.
+ */
+
+#include "PortabilityImpl.hh"
+#ifdef LOG4CPP_HAVE_IO_H
+#    include <io.h>
+#endif
+#ifdef LOG4CPP_HAVE_UNISTD_H
+#    include <unistd.h>
+#endif
+
+#include <memory>
+#include <stdio.h>
+#include <log4cpp/Category.hh>
+#include <log4cpp/FactoryParams.hh>
+
+#include <sys/types.h>
+#include <time.h>
+#include <sys/stat.h>
+#include <fcntl.h>
+#include <log4cpp/TimeRollingFileAppender.hh>
+#ifdef LOG4CPP_HAVE_SSTREAM
+#include <sstream>
+#endif
+
+#ifdef LOG4CPP_HAVE_GETTIMEOFDAY
+#include <sys/time.h>
+#else
+#ifdef LOG4CPP_HAVE_FTIME
+#include <sys/timeb.h>
+#else
+#include <time.h>
+#endif
+#endif
+
+namespace log4cpp {
+
+	TimeRollingFileAppender::TimeRollingFileAppender(const std::string& name, 
+			const std::string& fileName,
+			time_t maxFileAge, 
+			std::string backupPattern,
+			bool append,
+			mode_t mode) : 
+		LayoutAppender(name),
+		_flags(O_CREAT | O_APPEND | O_WRONLY),
+		_mode(mode),
+		_backupPattern(backupPattern),
+		_maxFileAge(maxFileAge),
+		_fileNamePrefix(fileName),
+		_backupIndex(0)
+	{
+		if (!append)
+			_flags |= O_TRUNC;
+
+		time_t _seconds;
+#ifdef LOG4CPP_HAVE_GETTIMEOFDAY
+		struct timeval tv;
+		::gettimeofday(&tv, NULL);
+		_seconds = tv.tv_sec;
+#else
+#ifdef LOG4CPP_HAVE_FTIME
+		struct timeb tb;
+		::ftime(&tb);
+		_seconds = tb.time;
+#else
+		_seconds = ::time(NULL);
+#endif
+#endif
+
+		char buff[257];                         
+		struct tm result;                       
+		localtime_r(&_seconds,&result);
+		result.tm_sec=0,result.tm_min=0,result.tm_hour=0;
+		time_t today = mktime(&result);
+		_fileCreateTime = ( (_seconds - today) / _maxFileAge) * _maxFileAge + today;
+		strftime(buff,257,_backupPattern.c_str(),localtime_r(&_fileCreateTime,&result));
+		_fileName.assign(_fileNamePrefix);
+		_fileName.append(buff);
+
+		_fd = ::open(_fileName.c_str(), _flags, _mode);
+	}
+
+	TimeRollingFileAppender::~TimeRollingFileAppender() {
+		close();
+	}
+
+	void TimeRollingFileAppender::setBackupPattern(std::string backupPattern) {
+		_backupPattern = backupPattern;
+	}
+
+	std::string TimeRollingFileAppender::getBackupPattern() const {
+		return _backupPattern;
+	}
+
+	void TimeRollingFileAppender::close() {
+		if (_fd!=-1) {
+			::close(_fd);
+			_fd=-1;
+		}
+	}
+
+	void TimeRollingFileAppender::setAppend(bool append) {
+		if (append) {
+			_flags &= ~O_TRUNC;
+		} else {
+			_flags |= O_TRUNC;
+		}
+	}
+
+	bool TimeRollingFileAppender::getAppend() const {
+		return (_flags & O_TRUNC) == 0;
+	}
+
+	void TimeRollingFileAppender::setMode(mode_t mode) {
+		_mode = mode;
+	}
+
+	mode_t TimeRollingFileAppender::getMode() const {
+		return _mode;
+	}
+
+	void TimeRollingFileAppender::_append(const LoggingEvent& event) 
+	{
+		time_t elapse = event.timeStamp.getSeconds() - _fileCreateTime;
+		if(  elapse >= _maxFileAge ) {
+			if (_backupIndex != 0) {
+				_fileNameList.push_back(_fileName);
+				if (_backupIndex <= _fileNameList.size()) {
+					std::string oldFileName = _fileNameList.front();
+					_fileNameList.pop_front();
+					unlink(oldFileName.c_str());
+				}
+			}
+			//_fileName = TimeRollingFileAppender::concatLogfileName(now, _maxFileAge, _fileNamePrefix, _fileCreateTime);
+			char buff[257];                         
+			struct tm result;                       
+			_fileCreateTime = (elapse / _maxFileAge) * _maxFileAge + _fileCreateTime;
+			strftime(buff,257,_backupPattern.c_str(),localtime_r(&_fileCreateTime,&result));
+			_fileName.assign(_fileNamePrefix);
+			_fileName.append(buff);
+
+			reopen();
+		}
+
+		//append
+		std::string message(_getLayout().format(event));
+		if (!::write(_fd, message.data(), message.length())) {
+			// XXX help! help!
+		}
+	}
+
+	bool TimeRollingFileAppender::reopen() {
+		if (_fileName != "") {
+			int fd = ::open(_fileName.c_str(), _flags, _mode);
+			if (fd < 0)
+				return false;
+			else {
+				if (_fd != -1)
+					::close(_fd);
+				_fd = fd;
+				return true;
+			}
+		} else {
+			return true;
+		}      
+	}
+	/*
+	   std::string TimeRollingFileAppender::concatLogfileName(const time_t now, 
+	   const time_t maxFileAge,
+	   const std::string& fileNamePrefix,
+	   time_t& fileCreateTime)
+	   {
+	   time_t fileCreateTime = (now / maxFileAge) * maxFileAge;
+	   char buff[257];                         
+	   struct tm result;                       
+	   std::string fileName(fileNamePrefix);
+	   strftime(buff,257,_backupPattern.c_str(),localtime_r(&fileCreateTime,&result));
+	   fileName.append(buff);
+	   return fileName;
+	   } 
+	   */
+
+	void TimeRollingFileAppender::setBackupIndex(int nIndex)
+	{
+		_backupIndex = nIndex;
+	}
+
+	int TimeRollingFileAppender::getBackupIndex()
+	{
+		return _backupIndex;
+	}
+
+	std::auto_ptr<Appender> create_time_roll_file_appender(const FactoryParams& params)
+	{
+		std::string name, filename;
+		bool append = true;
+		mode_t mode = 664;
+		time_t max_file_age = 86400;
+		std::string backup_pattern("%Y%m%d-%H%M%S");
+
+		params.get_for("time roll file appender").required("name", name)("filename", filename)("max_file_age",max_file_age)("backup_pattern",backup_pattern)
+			.optional("append", append)("mode", mode);
+
+		return std::auto_ptr<Appender>(new TimeRollingFileAppender(name, filename, max_file_age, backup_pattern, append, mode));
+	}
+
+}
diff --git a/tests/Makefile.am b/tests/Makefile.am
index d91e087..5bd3fd3 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -1,6 +1,6 @@
 TESTS = testCategory testFixedContextCategory testNDC testPattern \
 	testErrorCollision testPriority testFilter testProperties \
-	testConfig testPropertyConfig
+	testConfig testPropertyConfig testRollingFileAppender testTimeRollingFileAppender
 
 check_PROGRAMS = $(TESTS)
 check_DATA = log4cpp.init log4cpp.properties testProperties.properties \
@@ -37,6 +37,7 @@ testConfig_LDADD = $(top_builddir)/src/liblog4cpp.la
 
 testPropertyConfig_SOURCES = testPropertyConfig.cpp
 testPropertyConfig_LDADD = $(top_builddir)/src/liblog4cpp.la
+testPropertyConfig_LDFLAGS = -static
 
 testFilter_SOURCES = testFilter.cpp
 testFilter_LDADD = $(top_builddir)/src/liblog4cpp.la
@@ -50,5 +51,12 @@ testbench_LDADD = $(top_builddir)/src/liblog4cpp.la
 testErrorCollision_SOURCES = testErrorCollision.cpp
 testErrorCollision_LDADD = $(top_builddir)/src/liblog4cpp.la
 
+testRollingFileAppender_SOURCES = testRollingFileAppender.cpp
+testRollingFileAppender_LDADD = $(top_builddir)/src/liblog4cpp.la
+
+testTimeRollingFileAppender_SOURCES = testTimeRollingFileAppender.cpp
+testTimeRollingFileAppender_LDADD = $(top_builddir)/src/liblog4cpp.la
+
+
 distclean-local:
 	$(RM) -f *.log
diff --git a/tests/testTimeRollingFileAppender.cpp b/tests/testTimeRollingFileAppender.cpp
new file mode 100644
index 0000000..47e325a
--- /dev/null
+++ b/tests/testTimeRollingFileAppender.cpp
@@ -0,0 +1,113 @@
+#include <log4cpp/Category.hh>
+#include <log4cpp/TimeRollingFileAppender.hh>
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+#include <errno.h>
+#include <iostream>
+#include <unistd.h>
+#include <sys/types.h>
+#include <dirent.h>
+
+using namespace log4cpp;
+using namespace std;
+static const char* const test_message = "message";
+
+bool remove_impl(const char* filename)
+{
+   int res = remove(filename);
+   
+   if (res != 0 && errno != ENOENT)
+      cout << "Can't remove file '" << filename << "'.\n";
+
+   return res == 0 || (res != 0 && errno == ENOENT);
+}
+
+bool remove_files()
+{
+   if (!remove_impl("time_rolling_file.log"))
+      return false;
+   if (!remove_impl("time_rolling_file.log.1"))
+      return false;
+   if (!remove_impl("time_rolling_file.log.2"))
+      return false;
+
+   return true;
+}
+
+bool setup()
+{
+   if (!remove_files())
+      return false;
+
+   Category& root = Category::getRoot();
+   TimeRollingFileAppender *appender = new TimeRollingFileAppender("time-rolling-appender", "time_rolling_file", 1, ".%Y-%m-%d-%H:%M:%S.log");
+   appender->setBackupIndex(2);
+   root.addAppender(appender);
+   root.setPriority(Priority::DEBUG);
+
+   return true;
+}
+
+void make_log_files()
+{
+   Category::getRoot().debugStream() << test_message << 1;
+   sleep(1);
+   Category::getRoot().debugStream() << test_message << 2;
+   sleep(1);
+   Category::getRoot().debugStream() << test_message << 3;
+   Category::getRoot().debugStream() << test_message << 4;
+   sleep(1);
+   Category::getRoot().debugStream() << test_message << 5;
+}
+
+bool exists()
+{
+   struct dirent *dirp;
+   int file_num = 0;
+   DIR *dp = opendir("."); 
+   while ((dirp = readdir(dp))!= NULL) {
+       if (strncmp(dirp->d_name, "time_rolling_file", sizeof("time_rolling_file") - 1) == 0) {
+		   file_num ++;
+		   FILE* f = fopen(dirp->d_name, "r");
+		   if (f == NULL)
+		   {
+			   cout << "File '" << dirp->d_name << "' doesn't exists.\n"; 
+			   return false;
+		   }
+		   fclose(f);
+		   remove_impl(dirp->d_name);
+	   }
+   }
+   closedir(dp);
+   if (file_num != 2) {
+       cout << "File number("<< file_num << ") was wrong!" << endl;
+	   return false;
+   }
+   return true;
+}
+
+bool check_log_files()
+{
+   bool result = exists();
+
+   Category::shutdown();
+//   return result && remove_files();
+   return result;// && remove_files();
+}
+
+int main()
+{
+   if (!setup())
+   {
+      cout << "Setup has failed. Check for permissions on files 'time_rolling_file.log*'.\n";
+      return -1;
+   }
+
+   make_log_files();
+
+   if (check_log_files())
+      return 0;
+   else 
+      return -1;
+}
-- 
1.8.1.4

